# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).

## [Unrelease-Maybe]
- convert tokens to numbers inside ParserRules to improve performance
- allow toggle of validation to increase load speed
- add minimum tokens to match to graphparser edge constraints
- switch type=0 to type='Start' in ndfa graph

## [Unreleased-TODO]
- add to pypi
- adjust license to support any additional software (if necessary)
- add pyup support
- confirm settings/transcription.yml is compatible with new UTMO standard
- decide on parser/transliterator terminology
- remove visited from _add_subgraph_to_graph because cycle check means its
  no longer necessary
- add visualizations and check if _add_subgraph_to_graph is broken
- add documentation
- fix contributors
- add requirements.txt

## 0.2.2 - 2019-07-30
#### Added
- added settings/*
- added urdubiometer/cli.py,
- added tests/test_scanner.py
- added scanner/*
- use  of graphtransliterator using nodes as list rather than dict
  required rewrite of _minimize_ndfa()
- adjusted setup.py for markdown

#### Changed
- modified urdubiometer.py (minor)

#### Removed
- removed scanner.py

## 0.2.1 - 2019-07-28
#### Removed

- removed tests/test_graphparser.py
- removed urdubiometer/graphparser/* to replace with graphtransliterator

#### Changed

- init.py removed graphparser
- .travis.yml adjusted tags

## 0.2.0 - 2018-03-14
#### Added

- added graphparser._types.py module with ParserRule, ParserOutput,
  OnMatchRule, WhiteSpace, and DirectedGraph classes
- added tests/test_graphparser.py
- added graphparser init and constructors: from_yaml_file, from_yaml,
  from_dict. They are cascaded: from_yaml_file calls from_yaml, which calls
  from_dict. Added a "raw" parameter, to from_dict as to whether or the dict
  needs to be processed from easy-reading format (default is True)
- added _unescape_charnames to graphparser module to unescape \\N{CHARNAME}
  strings (from files, especially)
- added graphparser/validate.py to handle validation of raw and
  processed settings, using `Cerberus`
- created graphparser/initialize.py to convert rules, onmatch rules, and
  whitespace to internal types Rules, OnMatchRules, and Whitespace;
  and, to generate the parser's internal DirectedGraph
- added GraphParser.parse() method

#### Changed
- modified tests to fail
- updated contributing.md

## 0.1.2 - 2018-02-22
### Added
- initialized scanner.py and graphparser submodule
- added tests to check loading

## 0.1.1 - 2018-02-22
### Changed
- fixed badges in README.md

## 0.1.0 - 2018-02-22
### Added
- added AUTHORS.md, CONTRIBUTING.md (from cookiecutter, converted to md from rst)
- added docs, adjusting for markdown and sphinx_rtd_theme; enabled Napo
- added requirements_dev.txt, the dev requirements for a virtualenv; included m2r, sphinx_rtd_theme, and
- added Makefile (generated by cookiecutter)
- added MANIFEST.in, with some changes for md
- added setup.cfg, setup.py (customized for markdown), and tox.ini
- added urdubiometer directory with cli.py, \__init__.py, and urdubiometer.py (cookiecutter)
- added tests/test_urdubiometer.py (cookiecutter)
- generated module documentation using Sphinx

### Changed
- updated README.md based off cookiecutter
- updated .gitignore
- adjusted .travis.yml (may need some work)

## 0.0.1 - 2018-02-21
### Added
- This CHANGELOG.md file to record changes.
- CODEOFCONDUCT.md contains guidelines for participation.
- README.md created. It links to readthedocs.org, which I have initialized,
  and travis-ci.
- added LICENSE.md file, which is BSD and (c) Michigan State University
- added .travis.yml file for travis-ci
